<!-- <script setup lang="ts">
import {
  client,
  type Log,
  type ProfilePictureMetaFrameSpecs,
  type Report,
  type User
} from '@/scripts/api-helper'
import { GlobalError, useAppStore } from '@/stores/app'
import { onMounted, reactive } from 'vue'
import { RouterLink, useRoute } from 'vue-router'
import ImageCropper from '@/components/ImageCropper.vue'
import AppCard from '@/components/ui/AppCard.vue'
import ReportLine from '@/components/ReportLine.vue'
import LogLine from '@/components/LogLine.vue'
import profilePicturePlaceholder from '@/assets/example-profile.png'
import AppButton from '@/components/ui/AppButton.vue'

const route = useRoute()
const app = useAppStore()
const sciper = route.params.sciper as string

const state = reactive({
  user: null as User | null
})
</script>

<template>
  <main id="main">
    <div class="flex space-x-3 mb-3">
      <h1 class="grow mb-3 text-2xl dark:text-white font-semibold">
        Register new user - {{ sciper }}
      </h1>
      <span class="grow"></span>
      <RouterLink to="/admin/users">
        <AppButton>Back to all users</AppButton>
      </RouterLink>
      <RouterLink to="/admin/files">
        <AppButton>Back to all files</AppButton>
      </RouterLink>
    </div>
    <section v-if="!!state.user" class="bg-gray-50 antialiased dark:bg-gray-900">
      <AppCard dense class="mb-3">
        <div class="flex justify-between">
          <h1 class="grow mb-3 text-xl dark:text-white font-semibold">
            {{ state.user.official_firstname }} {{ state.user.official_lastname }}
          </h1>
          <p class="text-xl dark:text-white">
            Preferred: {{ state.user.preferred_firstname }} {{ state.user.preferred_lastname }}
          </p>
        </div>
        <div class="flex justify-between">
          <div>
            <span
              v-if="state.user.profile_picture_status === 'Ready'"
              class="bg-green-100 text-green-800 text-xs font-medium me-2 px-2.5 py-0.5 rounded dark:bg-green-900 dark:text-green-300"
            >
              Profile picture ready
            </span>
            <span
              v-else
              class="bg-red-100 text-red-800 text-xs font-medium me-2 px-2.5 py-0.5 rounded dark:bg-red-900 dark:text-red-300"
            >
              Profile picture status : {{ state.user.profile_picture_status }}
            </span>

            <span
              v-if="state.user.form_validated"
              class="bg-green-100 text-green-800 text-xs font-medium me-2 px-2.5 py-0.5 rounded dark:bg-green-900 dark:text-green-300"
            >
              Form validated
            </span>
            <span
              v-else
              class="bg-red-100 text-red-800 text-xs font-medium me-2 px-2.5 py-0.5 rounded dark:bg-red-900 dark:text-red-300"
            >
              Form not validated
            </span>
          </div>
          <a target="_blank" :href="`/api/admin/profile-picture/${sciper}?key=${app.adminKey}`"
            ><AppButton>Original profile picture file</AppButton></a
          >
        </div>
      </AppCard>
      <div class="flex justify-center space-x-4">
        <AppCard dense containerClass="flex flex-col items-center">
          <h4 class="text-xl mb-1 text-gray-900 dark:text-white">
            RemBG preview with AE={{ state.rembgAEPreview }}
          </h4>
          <div class="grow flex flex-col justify-center max-w-52">
            <img
              :class="`border border-slate-400 ${state.user.profile_picture_status === 'Ready' ? '' : 'opacity-60'}`"
              :src="
                `/api/admin/profile-picture/${state.user.sciper}?ae=${state.rembgAEPreview}&key=${app.adminKey}` ??
                profilePicturePlaceholder
              "
            />
          </div>

          <div class="mt-1">
            <label for="steps-range" class="mb-1 block font-medium text-gray-900 dark:text-white"
              >AE value: {{ state.rembgAEValue }}</label
            >
            <input
              id="steps-range"
              type="range"
              min="0"
              max="255"
              v-model.number="state.rembgAEValue"
              step="10"
              class="w-full h-2 bg-gray-200 rounded-lg appearance-none cursor-pointer dark:bg-gray-700"
            />
            <div class="mt-3 flex justify-between space-x-1">
              <AppButton :loading="state.rembgLoading" @click="regenerateRemBG"
                >Re-generate</AppButton
              >
            </div>
          </div>
        </AppCard>
        <AppCard dense containerClass="flex flex-col">
          <h4 class="text-xl mb-1 text-gray-900 dark:text-white">Frame configuration</h4>
          <div class="grow flex flex-col justify-center">
            <ImageCropper
              v-if="!!state.user.profile_picture_meta"
              :specs="state.user.profile_picture_meta.frame_specs"
              :picture-url="`/api/admin/profile-picture/${sciper}?key=${app.adminKey}`"
              @crop="regenerateOverride"
              :loading="state.overrideLoading"
              v-model:current-specs="state.overrideSpecs"
            />
            <div v-else class="max-w-52">
              <img
                class="border border-slate-400"
                :src="
                  `/api/admin/profile-picture/${state.user.sciper}?key=${app.adminKey}` ??
                  profilePicturePlaceholder
                "
              />
              <em class="text-gray-900 dark:text-white">No valid profile picture meta found</em>
              <AppButton>Re-generate metadata</AppButton>
            </div>
          </div>
        </AppCard>
        <AppCard dense containerClass="flex flex-col items center">
          <h4 class="text-xl mb-1 text-gray-900 dark:text-white">User preview</h4>
          <div class="grow flex flex-col justify-center max-w-52">
            <img
              :class="`border border-slate-400 ${state.user.profile_picture_status === 'Ready' ? '' : 'opacity-60'}`"
              :src="
                `/api/admin/profile-picture/${state.user.sciper}?cropped&key=${app.adminKey}` ??
                profilePicturePlaceholder
              "
            />
          </div>
        </AppCard>
        <AppCard v-if="state.overrideRandomValue" dense containerClass="flex flex-col items center">
          <h4 class="text-xl mb-1 text-gray-900 dark:text-white">Override preview</h4>
          <div class="grow flex flex-col justify-center max-w-52">
            <img
              class="border border-slate-400"
              :src="`/api/admin/profile-picture/${state.user.sciper}?admin_override&key=${app.adminKey}&r=${state.overrideRandomValue}`"
            />
          </div>
        </AppCard>
      </div>

      <div class="mt-5 space-y-1">
        <h4 class="mb-3 text-xl dark:text-white font-semibold">Reports</h4>
        <ReportLine
          v-for="report of state.reports"
          v-bind:key="report.id"
          :report="report"
          @done="() => toggleDone(report)"
        />
      </div>

      <div class="mt-5 space-y-1">
        <h4 class="mb-3 text-xl dark:text-white font-semibold">Logs</h4>
        <LogLine v-for="log of state.logs" v-bind:key="log.id" :log="log" />
      </div>
    </section>
  </main>
</template> -->
